SystemOrganization addCategory: #TusLibros!

Object subclass: #Cart
	instanceVariableNames: 'id items catalogo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cart class methodsFor: 'instance-creation' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 20:13'!
newCartWithCatalog: aCatalog
	^ self new emptyCartWithCatalog: aCatalog! !

!Cart methodsFor: 'adding' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 20:00'!
add: anISBN 
	
	
	items add: anISBN! !

!Cart methodsFor: 'adding' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 20:06'!
add: anISBN withQuantity: aQuantity 
	
	
	(catalogo includes: anISBN ) ifFalse:[^ Error signal: 'El libro no pertenece al catlogo' ].
	items add: anISBN withOccurrences: aQuantity ! !

!Cart methodsFor: 'testing' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 20:01'!
catalog

	^catalogo! !

!Cart methodsFor: 'Initializing' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 19:58'!
emptyCartWithCatalog: aCatalog
	
	items := Bag new.
	catalogo := aCatalog.! !

!Cart methodsFor: 'testing' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 19:54'!
hasItem: anISBN withQuantity: aQuantity

	^(items occurrencesOf: anISBN) = aQuantity  ! !

!Cart methodsFor: 'testing' stamp: 'EmilianoMenendezEzequielNicols 5/27/2013 21:46'!
isEmpty

	^items isEmpty! !

!Cart methodsFor: 'testing' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 16:39'!
listItems

	^items valuesAndCounts! !

!Cart methodsFor: 'testing' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 19:32'!
size

	^items size! !

Object subclass: #Cashier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cashier class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 20:42'!
cantCheckoutEmptyCartMessage
	^ 'Cant checkout an empty cart'! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 21:00'!
checkOut: aCart 
	
	(aCart isEmpty) ifTrue: [^ Error signal: self class cantCheckoutEmptyCartMessage].
	 ^2! !

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!TusLibrosTest methodsFor: 'cart tests' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 21:46'!
carrito
	
		^ Cart newCartWithCatalog: self catalogo! !

!TusLibrosTest methodsFor: 'cart tests' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 21:47'!
carritoConUnLibro
	| book1 book2 catalog |
	book1 := '3514564564674'.
	book2 := '6464564564564'.
	
	catalog := Bag new.
	catalog add: book1.
	catalog add: book2.
	
	^ (Cart newCartWithCatalog: catalog) add: book1! !

!TusLibrosTest methodsFor: 'cart tests' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 21:46'!
catalogo
	| book1 book2 catalog |
	book1 := '3514564564674'.
	book2 := '6464564564564'.
	
	catalog := Dictionary new.
	catalog add: book1.
	catalog add: book2.
	
	^ catalog! !

!TusLibrosTest methodsFor: 'cart tests' stamp: 'EmilianoMenendezEzequielNicols 5/27/2013 20:44'!
test01AllCartsAreCreatedEmpty
	"Todo carrito se crea vaco"

	self assert: self carrito isEmpty.! !

!TusLibrosTest methodsFor: 'cart tests' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 19:53'!
test02AfterAddingTheFirstBookCartShouldNotBeEmpty
	"Luego de agregarle libros, el carrito no est vaco"

	self deny: (self carrito add: '6464564564564' withQuantity: 1) isEmpty.! !

!TusLibrosTest methodsFor: 'cart tests' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 19:53'!
test03AfterAddingMoreBooksCartShouldStillNotBeEmpty
	"Luego de agregarle libros, el carrito no est vaco"

	| aBook aCartWithBooks|
	
	aBook:= '35145645646748'.
	
	aCartWithBooks:=  self carrito add: aBook withQuantity: 1.
	
	self deny: (aCartWithBooks add: aBook withQuantity: 1) isEmpty.
	! !

!TusLibrosTest methodsFor: 'cart tests' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 19:54'!
test03BooksAddedShouldAppearWithTheirQuantities
	
	| aBook aCartWithBooks|
	
	aBook:= '35145645646748'.
	
	aCartWithBooks:=  self carrito add: aBook withQuantity: 1.
	aCartWithBooks add: aBook withQuantity: 1.
		
	self assert: (aCartWithBooks hasItem: aBook  withQuantity: 2)! !

!TusLibrosTest methodsFor: 'cart tests' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 19:54'!
test03CartShouldOnlyHaveTheBooksThatWereAdded
	
	| book1 book2 aCartWithBooks|
	
	book1:= '35145645646748'.
	book2:= '6464564564564'.
	
	aCartWithBooks:=  self carrito add: book1 withQuantity: 1.
	aCartWithBooks add: book2 withQuantity: 1.
	
	self assert: (aCartWithBooks hasItem: book1 withQuantity: 1).
	self assert: (aCartWithBooks hasItem: book2 withQuantity: 1).	
	self assert: (aCartWithBooks size = 2)
! !

!TusLibrosTest methodsFor: 'cashier' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 21:37'!
testCheckoutOfCartWithSingleElementShouldReturnSinglePrice

	|cart aCashier expectedTotal |
	
	aCashier:= Cashier new.
	cart := self carritoConUnLibro.
	expectedTotal := 2.
	
	self assert: ((aCashier checkOut: cart) = expectedTotal) ! !

!TusLibrosTest methodsFor: 'cashier' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 20:48'!
testCheckoutOfEmptyCartShouldRaiseAnError

	|emptyCart aCashier|

	emptyCart := Cart newCartWithCatalog: Bag new.
      aCashier := Cashier new. 

 	self should: [aCashier checkOut: emptyCart ] 
		raise: Error 
		withExceptionDo: [ :anError |  self assert: anError messageText = Cashier cantCheckoutEmptyCartMessage]  ! !
